#! /usr/bin/env node

const params = process.argv.slice(4);
const myModule = require(process.argv[2]);

var activeHandles = require('active-handles');

if (!myModule) {
  throw new Error(`No module named ${myModule} found`);
}
if (!myModule[process.argv[3]]) {
  throw new Error(`${process.argv[3]} is not a function exported from ${myModule}`);
}

var EXIT = false;

var callback = function ( err, result ) {
    if( err ) {
        console.log( "ERROR : " + err );
        EXIT = true;
    }    
    else {
        var fs = require('fs');
        fs.writeFile("./RETURN_VAL", result , function(error) {
            if(error) {
                console.log(error);
                EXIT = true;
            }

            console.log("The file was saved!");
       });
    }
    EXIT = true;
}

myModule[process.argv[3]]( params[0], params[1], callback );


var exitGraceTimer = null;
(function wait () {

    var opts = {};
    opts.highlight = false;
    activeHandles.print( opts );

    var handles = process._getActiveHandles();

/*
    console.log( "loop handles (" + handles.length + ") : ");
    handles.forEach(function (handle) {
        console.log( "\t" + handle );
    });
*/
    var requests = process._getActiveRequests();

    //console.log( "loop requests (" + requests.length + ")");

    if (!EXIT) setTimeout( wait, 100 );

    // why 3? - testing has revealed that the handles are 2 objects and a timer when the underlying 
    // lambda has exited.  I believe they are 1.) launcher module, 2.) user module, 3.) wait timer
    // this is purely based on observation, and we may need something more robust here.  not sure how 
    // to identify the names of the handles

    if( handles.length <= 3 ) {
        if( !exitGraceTimer ) {
            //console.log( "starting grace timer...");
            exitGraceTimer = Date.now();
        }
        else if( Date.now() - exitGraceTimer > 3000 ) {
            //console.log( "3 seconds is up, exiting...");
            EXIT = true;
        }
    }

})();
